//変更可能定数
var epg_hour_height = 80;	//1時間のドット数
var epg_start_hour = 5;	//epgの始まり時間
var station_height = 23;
//変数
var station_max = 7;
var screen_width = 640;
var service_tbl;
var epg_data = {};	//受信したepgデータ
var old_epg_data = {};
var old_epg_data_date = 0;
var cmdpreset, apppreset;
var stationmode_pos, station_mode_viewdate;
//.固定バー
var headerobj, timeobj, header_height, time_width, station_initpos, touch_timer_id=-1, touch_pos_x=0, touch_pos_y=0;
$(document).ready(function(){
	screen_width = document.documentElement.clientWidth;
	header_height = parseInt($(".header").css("height"));
	$(".header").css("width", (screen_width)+"px");
	$(".header_stmode").css("width", (screen_width)+"px");
	$(".nowline").css("width", (screen_width)+"px");
	var prog_width = screen_width-25;
	$(".stationblock").css("width", prog_width+"px");
	$(".programbody").css("width", prog_width+"px");
	//高さの調整
	var blk = $(".timecolumn").children("div");
	blk.css("height", ""+(epg_hour_height-3)+"px");
	blk.eq(0).css("height", ""+(epg_hour_height-2)+"px");
	for(var i = 0; i< 24; i++) blk.eq(i).html(""+(epg_start_hour+i));
	blk = $(".programbody").children("div")
	for(var i = 0; i< 12; i++) blk.eq(i).css({"height":""+epg_hour_height+"px", "top":""+(epg_hour_height*(i*2))+"px"});
	$(".programbody").css("height", ""+(epg_hour_height*24)+"px");

	timeobj = $(".timecolumn");
	time_width = parseInt(timeobj.css("width"));
	headerobj = $(".stationblock");
	station_initpos = parseInt(headerobj.css("left"));

/*	if(navigator.userAgent.indexOf("Android")!=-1){
		document.addEventListener("touchend", head_touchEnd, false);
	}*/
	document.addEventListener("touchstart", head_touchMove, false);
	document.addEventListener("touchmove", head_touchMove, false);
	document.addEventListener("touchend", head_touchMove, false);
	//PC用
	document.onmouseup = head_touchMove;
});
//.拡大縮小対応
var erase_flag=false;
function round(v) {
	return Math.round(v*100)/100;
}
function head_touchEnd(event) {
	var touch = event.changedTouches[0];
	var x = touch.screenX, y = touch.screenY;
	if (y<header_height) {
		event.preventDefault();
		//リンク当たり判定
		var anchorobj = $(".linkblock").find("a");
		for(var i = 0; i< anchorobj.length; i++) {
			var obj = anchorobj.eq(i);
			var a = obj.offset().left, b = obj.width(), c = obj.offset().top, d = obj.height();
			if (a<=x && x<=a+b && c<=y && y<=c+d) {
				location.href = obj.attr("href");
				break;
			}
		}
	}
}
function head_touchMove() {
	var zoomer = round(document.body.clientWidth / window.innerWidth);
//	$("#debug").html("z:"+zoomer+" "+document.body.clientWidth+","+window.innerWidth);

	if (!erase_flag && touch_pos_x!=window.pageXOffset) {
		//一旦消す
		headerobj.css("left", "-2048px");
		timeobj.css("left", "0px");
		erase_flag = true;
		$("#debug").html("erase1");
	}

	head_watch_set();
}
function head_watch_set() {
	if (touch_timer_id<0) {
		touch_timer_id = setTimeout(head_watch_exec, 200);
	}
}
function head_watch_exec() {
	touch_timer_id = -1;

	if (!erase_flag && touch_pos_x!=window.pageXOffset) {
		//一旦消す
		headerobj.css("left", "-2048px");
		timeobj.css("left", "0px");
		erase_flag = true;
		$("#debug").html("erase1");
	}

	//console.log("x:"+window.pageXOffset);
	if (touch_pos_x==window.pageXOffset && touch_pos_y==window.pageYOffset) {
		headerobj.css("left", ""+(station_initpos-touch_pos_x)+"px");
		if (touch_pos_x>=time_width) {
			timeobj.css("left", touch_pos_x+"px").show();
		}
		//$("#debug").html("z:"+window.pageXOffset+","+window.pageYOffset+" fix");
		erase_flag = false;
		$("#debug").html("fix");
		return;
	}
	touch_pos_x = window.pageXOffset;
	touch_pos_y = window.pageYOffset;
	head_watch_set();
}
//.htmlから呼ばれる関数
function reload() {
	//リロード

	//キャッシュ情報を破棄
	epg_data = {};
	old_epg_data = {};
	old_epg_data_date = 0;
	//予約ダウンロード
	epg_crc_download();
}
function cache_clear() {
	command_page_cache_clear();
}
//日付変更
function push_date() {
	//今日に移動
	var today_dc = daycount(new Date());
	var today_h = today_dc*24-9;	//時差を補正
	today_h += epg_start_hour;	//午前4時に設定
	todaydate = new Date();
	todaydate.setTime(today_h*60*60*1000);
	viewdate = new Date(todaydate.getTime());
	epg_download(viewdate);
	movenow();
}
//1週間モード
function push_station(pos) {
	$(".header_stmode").show();
	stationmode_pos = pos;
	station_mode_viewdate = viewdate;
	viewdate = new Date(todaydate.getTime());
	if (station_mode_viewdate<todaydate) {
		//先週
		stmode_lastweek();
	} else {
		stmode_thisweek();
	}
}
function stmode_back() {
	$(".header_stmode").hide();
	page_channel_init(-1);	//現在のページを開き直す
	viewdate = station_mode_viewdate;
	epg_download(viewdate);
}
function stmode_lastweek() {
	//先週
	viewdate = new Date(todaydate.getTime());
	viewdate.setDate(viewdate.getDate() - 8);
	epg_week_download(station_idx_tbl[stationmode_pos]);
}
function stmode_thisweek() {
	//今週
	viewdate = new Date(todaydate.getTime());
	epg_week_download(station_idx_tbl[stationmode_pos]);
}
//
function redraw() {
	screen_width = document.documentElement.clientWidth;
	header_height = parseInt($(".header").css("height"));
	$(".header").css("width", (screen_width)+"px");
	$(".header_stmode").css("width", (screen_width)+"px");
	$(".nowline").css("width", (screen_width)+"px");
	var prog_width = screen_width-25;
	$(".stationblock").css("width", prog_width+"px");
	$(".programbody").css("width", prog_width+"px");
}

//.番組表
var day_of_week_tbl = [
	"日", "月", "火", "水", "木", "金", "土"
];
//var GenreColor;
var GenreColor = [
	"#F3DFFC", 		//ニュース・報道
	"#EDFA90",		//スポーツ
	"#97D5F9",		//情報・ワイドショー
	"#F5C5F8",		//ドラマ
	"#FEC7A2",		//音楽
	"#E6E6FF",		//バラエティ
	"#CBEAC3",		//映画
	"#FDE47F",		//アニメ・漫画
	"#83d999",		//ドキュメンタリー・教養
	"#FFEEFA",		//劇場・公演
	"#FFEEFA",		//趣味・教育
	"#FFEEFA",		//福祉
	"#c0c0c0",		//はずれ
	"#808080",		//放送無し
	"#808080",
	"#f0f0f0",
];
var detail_obj;
var insert;
var todaydate;
var station_idx_tbl;
$(document).ready(function(){

	if (!localstorage_check()) return;
	if (!privateStorage.getItem("radio_service_list")) {
		//チャンネル未設定
		window.open("station.html","","");
		return;
	}
	service_tbl = JSON.parse(privateStorage.getItem("radio_service_tbl"));

	//テーブル初期化
//	GenreColor = JSON.parse(privateStorage.getItem("GenreColor"));
//	GenreColor = new Array();
	//epg初期化
	nowline();
	insert = $("#insert");
	//今日の日付
	var today_dc = daycount(new Date());
	var today_h = today_dc*24-9;	//時差を補正
	today_h += epg_start_hour;	//午前4時に設定
	todaydate = new Date();
	todaydate.setTime(today_h*60*60*1000);
	viewdate = new Date(todaydate.getTime());

	//ページindex作成
	page_init();
	page_channel_init(0);

	epg_crc_download();
});
window.onload=function(){
	movenow();
}
var resize_timer = false;
$(window).resize(function() {
	if (resize_timer !== false) {
		clearTimeout(resize_timer);
	}
	resize_timer = setTimeout(function() {
		redraw();
	}, 200);
});
//epg補助関数
function daycount(dateobj) {
	//Dateを日付番号（午前4時基準）に変換
	var tmp = dateobj.getTime();
	tmp -= epg_start_hour * 3600 * 1000;
	tmp += 9 * 3600 * 1000;
	tmp /= 24 * 3600 * 1000;
	//console.log("daycount:"+tmp);
	return Math.floor(tmp);
}
function getStationIndex(id) {
	var result = -1;
	var stid = "0000"+id;	//12文字
	if (id.length>12) {
		stid = "0000"+id.substring(0, 12);	//16文字
	}
	for (i = 0; i< station_idx_tbl.length; i++) {
		if (station_idx_tbl[i]==stid) {
			result = i;
			break;
		}
	}
	return result;
}
var epg_current = null, epg_height;
var reserve_window = null;
function _hitchk(cx, cy, obj) {
	var point = obj.offset();
	var tx = point.left, ty = point.top;
	var tw = obj.width(), th = obj.height();
	//console.log("poi :"+poi.left + ","+poi.top);
	if (tx<=cx && cx<tx+tw && ty<=cy && cy<ty+th) {
		return true;
	}
	return false;
}
function epgclick(e) {
	var x = e.pageX, y = e.pageY;
	//時間とのあたり判定
	if (_hitchk(x, y, $(this).find(".progmin"))) {
		reserve_window_release();
		time_click($(this).find(".progmin")[0]);
		return;
	}
	if (_hitchk(x, y, $(this).find(".detail"))) {
		reserve_window_release();
		var i, id = this.id, stpos = parseInt($(this).attr("name"));
		//詳細ウィンドウ開く
		var progmax = proglist[stpos].length;
		for (i = 0; i< progmax; i++) {
			if (proglist[stpos][i].id==id) {
				detail_obj = $.extend(true, {}, proglist[stpos][i]);
				detail_obj.station_index = stpos;
				//console.log("title:"+detail_obj.ShortInfo.event_name);
				//window.open("detail.html","epg_detail",'width=460,height=600,left=10,top=40,menubar=no,toolbar=no,location=no,status=no,resizable=no,scrollbars=yes');
				var dobj = $(this).find(".detail");
				var dpt = dobj.offset();
				var x = parseInt(dpt.left), y = parseInt(dpt.top) + dobj.height();
				//画面外から戻す
				var obj = $(".idetail");
				var dw = obj.width()+7, dh = obj.height()+7;
				var ww = $(window).width(), wh = $(document).height();
				if (x+dw>ww) x = ww-dw;
				if (y+dh>wh) y = wh-dh;
				//
				$(".idetail").show().css({"left":x+"px","top":y+"px"});
				document.getElementById("idetail").contentWindow.init();
				break;
			}
		}
		return;
	}

	var _this = this;

	reserve_window_release();
	if (epg_current && epg_current.attr("id") == _this.id) {
		epgrestore();
		return;
	}
	epgrestore();
	epg_current = $(_this);
	epg_height = epg_current.css( "height" );
	epg_current.css( "height", "" );
	if (parseInt(epg_current.css( "height" ))<parseInt(epg_height)) {
		epg_current.css( "height", epg_height );
	}
	epg_current.css( "z-index", "1" );
//	var text = '<div id="'+obj.id+'" name='+stationindex+' class="block border prog" style="BACKGROUND-COLOR: '+GenreColor[genreidx]+
//	'; WIDTH: '+w+'%; LEFT: '+x+'%; HEIGHT: '+h+'px; TOP: '+y+'px"><div class="content"><span class="rec"></span>'+tt+
//	' <span class="progtitle">'+title+'</span>'+'<br><span class="subtitle">'+explan+'</span><span class="buttons"></span></div></div>\n';
}
function epgrestore() {
	if (epg_current) {
		epg_current.css( "height", epg_height );
		epg_current.css( "z-index", "0" );
	}
	epg_current = null;
}

function time_click(t) {
	reserve_window = $(t).parent().parent();
	var id = reserve_window.attr("id");
	$(".boxdbg").html(id);
	//予約ウィンドウ作成
	var x = parseInt(reserve_window.css("left")), y = parseInt(reserve_window.css("top")) + $(t).height();
	$(".reservebox").show().css({"left":x+"px","top":y+"px"});
	//予約中か確認
	if (reserve_window.find(".rec").css("display")=="block") {
		$(".reservebox").find("a").show();
	} else {
		$(".reservebox").find("a").hide();
	}
	//ラジオ用追加
	var stpos = parseInt(reserve_window.attr("name"));
	var obj = null, progmax = proglist[stpos].length;
	for (var i = 0; i< progmax; i++) {
		if (proglist[stpos][i].id==id) {
			obj = $.extend(true, {}, proglist[stpos][i]);
			break;
		}
	}
	$("[name=everyweek]").prop('checked', false);
	if (obj) {
		//曜日チェック
		for(var i=0; i< 7; i++) $("[name=week"+i+"]").prop('checked', false);
		var date = convert_json2date(obj.start_time);
		$("[name=week"+date.getDay()+"]").prop('checked', true);
	}
/*	//プリセット自動選択
	var stationname = service_tbl["0000"+id.substr(0, 12)];;
	var sel = $(".preset").children();
	for(var i = 0; i< sel.length; i++) {
		if (sel.eq(i).html()==stationname) {
			$(".preset").val(sel.eq(i).val());
			break;
		}
	}*/
	//コマンドプリセット
	var current_preset = privateStorage.getItem("current_preset");
	var sel = $(".preset"), current_idx = 0;
	sel.empty();
	for(var i = 0; i< cmdpreset.length; i++) {
		sel.append($('<option>').html(cmdpreset[i]).val(i));
		if (cmdpreset[i]==current_preset) current_idx = i;
	}
	sel.val(current_idx);
	return;
}


function reserve_window_release() {
	detail_close();
	if (reserve_window) {
		$(".reservebox").hide();
		reserve_window = null;
	}
}
function popupclick() {
	console.log("popupclick");
}

//..詳細
function detail_get() {
	return detail_obj;
}
function detail_next(d_obj) {
	var nexttime = d_obj.unix_time + d_obj.durationSec;
	var stid = getStationIndex(d_obj.id);
	if (stid<0) return null;

	if ($(".header_stmode").css("display")=="block") {
		stid = d_obj.station_index;
	}
	var progmax = proglist[stid].length;
	for (var i = 0; i< progmax; i++) {
		var obj = proglist[stid][i];
		if (obj.unix_time==nexttime) {
			var newobj = $.extend(true, {}, obj);
			newobj.station_index = stid;
			detail_obj = newobj;
			return newobj;
		}
	}
	return null;
}
function detail_prev(d_obj) {
	var stid = getStationIndex(d_obj.id);
	if (stid<0) return null;

	if ($(".header_stmode").css("display")=="block") {
		stid = d_obj.station_index;
	}
	var lastttime = d_obj.unix_time;
	var progmax = proglist[stid].length;
	for (var i = 0; i< progmax; i++) {
		var obj = proglist[stid][i];
		if (obj.unix_time+obj.durationSec==lastttime) {
			var newobj = $.extend(true, {}, obj);
			newobj.station_index = stid;
			detail_obj = newobj;
			return newobj;
		}
	}
	return null;
}
function detail_nextch_sub(d_obj, d_time, ofs) {
	var stid = getStationIndex(d_obj.id);
	if (stid<0) return null;
	if ($(".header_stmode").css("display")=="block") {
		//週刊番組表
		stid = d_obj.station_index;
		//
		d_time += (9-epg_start_hour)*60*60;
		var t = d_time % (24*60*60);
		d_time = todaydate.getTime()/1000 + (24*stid+t)*60*60;
	}
	var startstation = stid;
	do {
		if ($(".header_stmode").css("display")=="block") {
			//週刊番組表
			stid += ofs;
			d_time += ofs*24*60*60;
			if (stid<0) {
				d_time += 8*24*60*60;
				stid = station_max-1;
			}
			if (stid>=station_max) {
				d_time -= 8*24*60*60;
				stid = 0;
			}
		} else {
			stid = (stid+station_max+ofs)%station_max;
		}

		var progmax = proglist[stid].length;
		for (var i = 0; i< progmax; i++) {
			var obj = proglist[stid][i];
			if (!obj.unix_time) continue;
			if (obj.unix_time<=d_time && d_time<obj.unix_time+obj.durationSec ) {
				var newobj = $.extend(true, {}, obj);
				newobj.station_index = stid;
				console.log("newobj:"+JSON.stringify(newobj));
				detail_obj = newobj;
				return newobj;
			}
		}
		console.log("空白:"+stid);
	} while(stid!=startstation);
	return null;
}
function detail_nextch(d_obj, d_time) {
	return detail_nextch_sub(d_obj, d_time, 1);
}
function detail_prevch(d_obj, d_time) {
	return detail_nextch_sub(d_obj, d_time, -1);
}
function detail_getStationName() {
	var result = -1;
	var id = detail_obj.id;
	var stid = "0000"+id;	//12文字
	if (id.length>12) {
		stid = "0000"+id.substring(0, 12);	//16文字
	}
	return service_tbl[stid].name;
}
function detail_close() {
	$(".idetail").hide();
}
//detailからautoreserveを呼び出す
var scroll_y;
function detail_autoreserve() {
	dbg("detail_autoreserve");
	open_search();
	detail_close();
}
function open_search() {
	dbg("iautoreserve");
	edit_reserve = {};
	var text = privateStorage.getItem("search_condition");
	if (text!=null && text.length>0) {
		edit_reserve = JSON.parse(text);
	}
	var word = detail_obj.ShortInfo.event_name;
	word = word.replace(/\s+/g, '&');
	word = word.replace(/　/g, '&');
	edit_reserve.ReserveID = -1;
	edit_reserve.SearchTitle = "1";
	edit_reserve.Keyword = word;
	edit_reserve.NotWord = "";
	edit_reserve.Station = service_tbl["0000"+detail_obj.id.substr(0, 12)].tag;
	var date = convert_json2date(detail_obj.start_time);
	edit_reserve.DayOfWeek = 1<<date.getDay();
	edit_reserve.SearchTitle = 1;
	edit_reserve.SearchPfm = 0;
	edit_reserve.SearchExplan = 0;
	//画面入れ替え
	scroll_y = $(window).scrollTop();
	$(".epgbase").hide();
	$(".iautoreserve").show();
	document.getElementById("iautoreserve").contentWindow.draw();
}
//..editから呼ばれる
var edit_reserve;
function get_edit_reserve() {
	return edit_reserve;
}
function edit_close() {
	$(".iautoreserve").hide();
	$(".epgbase").show();
	$(window).scrollTop(scroll_y);
}
function edit_get_buttons() {
	return "<input type='button' value='保存して閉じる' onclick='window.parent.edit_update(read_form())'>　<input type='button' value='キャンセル' onclick='window.parent.edit_close()'><input type='checkbox' id='delayreserve'><label for='delayreserve'>放送終了後に検索して予約する</label>　<input type=number name='delayhour' size=1 value='0'>時間後";
}
var new_autoreserve;
function edit_update(obj) {
	//新規条件として保存	DLして追加して保存
	new_autoreserve = obj;
	cgi_url("/cgi?cmd=SendEnumAutoReserve", autoreserve_download_success);
}
function autoreserve_download_success(response) {
	var autoreserve = response;
	new_autoreserve.Tag = _new_tag(autoreserve);
	autoreserve.push(new_autoreserve);
	//即保存
	cgi_url("/cgi?cmd=SendUpdateAutoReserve&param="+encodeURIComponent(JSON.stringify(autoreserve)), autoreserve_upload_success, autoreserve_upload_success);
}
function autoreserve_upload_success() {
	edit_close();
}
//..時間線
function nowline() {
	var tobj = new Date();
	var h = tobj.getHours(), m = tobj.getMinutes();
	h = (h + 24 - epg_start_hour)%24;
//	console.log("test:"+(header_height + Math.floor(157*h + 157*m/60))+"px" );
	$(".nowline").css("top", (header_height + Math.floor(epg_hour_height*h + epg_hour_height*m/60))+"px");
	var sec = tobj.getSeconds();
	setTimeout(nowline, (60-sec)*1000);
}
function movenow() {
	var tobj = new Date();
	var h = tobj.getHours();
	h = ((h + 24 - epg_start_hour)%24) -1;
	window.scrollTo(0, h*epg_hour_height);
}

//..epgダウンロード
var station_idx = -1;
var viewdate;
var epg_datetext, epg_dow;
var proglist = new Array();
function epg_download(dateobj) {
	//
	var targettime = dateobj.getTime();
	viewdate = new Date();
	viewdate.setTime(targettime);
	//
	insert.html("");
	//
	epg_dow = viewdate.getDay();
	epg_datetext = viewdate.getFullYear()+format02d(viewdate.getMonth()+1)+format02d(viewdate.getDate());
	var header = viewdate.getFullYear()+"/"+format02d(viewdate.getMonth()+1)+"/"+format02d(viewdate.getDate())+"("+day_of_week_tbl[epg_dow]+")";
	$(".datestr").html(header);
	//
	station_idx = 0;
	if (station_idx_tbl.length==0) return;	//空っぽは何もしない

	epg_download_conn();
}
function epg_week_download(svkey) {
	//
	station_idx_tbl = new Array();
	for(var i = 0; i< 8; i++) {
		station_idx_tbl.push(svkey);
	}
	//
	insert.html("");
	//
	$(".stmode_name").html(service_tbl[svkey].name);
	//
	station_idx = 0;

//page_channel_initから持ってきた
	//局名枠
	var hobj = $(".stationblock").children("div").empty();
	station_max = station_idx_tbl.length;
	var w = 100/station_max;
	for(var i = 0; i< station_max; i++) {
		hobj.append("<div class='block station' style='WIDTH: "+(w-0.2)+"%; LEFT: "+w*i+"%; HEIGHT: "+station_height+"px; TOP: 0px'></div>");
	}

	epg_download_conn();
}
function epg_download_conn() {
	if (epg_data[station_idx_tbl[station_idx]]) {
		//ウィークリー＆今日明日で取得できるepgは持っている
		
		// && epg_data_date[station_idx_tbl[station_idx]] == viewdate
		//ターゲット日付のepgを持っているかチェック
//dbg("--time="+obj.start_time+" pgdate="+pgdate.getTime());
		var vt_s = viewdate.getTime();
		var vt_e = vt_s+(24*60*60*1000);
		var program = epg_data[station_idx_tbl[station_idx]];
		for (var i = 0; i< program.length; i++) {
			var obj = program[i];
			//日付検査
			var pgdate = convert_json2date(obj.start_time);
			var pd_s = pgdate.getTime();
			if (vt_s<=pd_s && pd_s<vt_e) {
				//その日のデータがある
				console.log("キャッシュ使用");
				epg_rend(epg_data[station_idx_tbl[station_idx]]);
				return;
			}
		}
		//範囲外ダウンロード
		if (old_epg_data_date != viewdate) {
			old_epg_data = {};
			old_epg_data_date = 0;
		}
		cgi_url("/cgi?cmd=SendEnumOldPgInfo&service="+station_idx_tbl[station_idx]+"&date="+viewdate.toJSON(), old_epg_download_success, epg_download_error);
		return;
	}
	//ダウンロード
	cgi_url("/cgi?cmd=SendEnumRadioPgInfo&service="+station_idx_tbl[station_idx], epg_download_success, epg_download_error);
}
function epg_download_next() {
	station_idx++;
	if (station_idx<station_idx_tbl.length) {
		if ($(".header_stmode").css("display")=="block") {
			viewdate.setDate(viewdate.getDate() + 1);
		}
		epg_download_conn();
	} else {
		//DL終了
		station_idx = -1;
/*		//予約チェック付ける
		for(var i = 0; i<reserve_list.length; i++) {
			//今表示している日付かチェックを入れる
			//表示しているチャンネルかチェック
			var recobj = $("#"+reserve_list[i].id).find(".rec").show();
			recobj.css("background-color", reserve_list[i].tuner_color);
			recobj.html("<span style='color: #ffffff;'>"+reserve_list[i].tuner_name+"</span>");
			//recobj.attr("name", reserve_list[i].ReserveID);
		}*/

		reserve_reload(epg_download_done);
	}
}
function epg_download_done() {
	$(".prog").click(epgclick);
}
function epg_download_success(data) {
	console.log("epg_download_success");
	//受信したものをメモリに保存
	epg_data[station_idx_tbl[station_idx]] = data;
	//
	epg_rend(data);
}
function epg_download_error(err) {
	console.log("epg_download_error:"+err);
	setTimeout(epg_download_next, 100);
}
function old_epg_download_success(data) {
	console.log("old_epg_download_success");
	//受信したものをメモリに保存
	old_epg_data[station_idx_tbl[station_idx]] = data;
	old_epg_data_date = viewdate;
	//
	epg_rend(data);
}
//..epg描画
function epg_rend(data) {
	try {
		var program = data;//JSON.parse(data);
		//console.log(JSON.stringify(program));
		var dc_rend;

		if ($(".header_stmode").css("display")=="block") {
			//ステーションモード
			//dc_rend = daycount(todaydate) + station_idx;	//レンダリングすべき日付
//dbg("epg_rend:"+viewdate);
			dc_rend = daycount(viewdate);	//レンダリングすべき日付
			var h = dc_rend*24-9;	//時差を補正
			h += epg_start_hour;	//午前4時に設定
			var date = new Date();
			date.setTime(h*60*60*1000);

			$(".stationblock").children().find("div").eq(station_idx).html(formatdate(date));
		} else {
			$(".stationblock").children().find("div").eq(station_idx).html(service_tbl[station_idx_tbl[station_idx]].name);
			dc_rend = daycount(viewdate);	//レンダリングすべき日付
		}

		for (var i = 0; i< program.length; i++) {
			var obj = program[i];
			try {
				//日付検査
				var pgdate = convert_json2date(obj.start_time);
				var start_h = (pgdate.getHours()-epg_start_hour+24)%24;	//開始時間y座標(4時を0に)
				var diff = daycount(pgdate)-dc_rend;
				if (diff>0 || diff<-1) continue;
				if (diff==-1) {
					//開始時間が昨日
					pgdate.setSeconds(pgdate.getSeconds() + obj.durationSec - 1);
					if (daycount(pgdate)!=dc_rend) continue;	//終了時間も範囲外
					//終了時間が範囲内
					pgdate = convert_json2date(obj.start_time);
					start_h = pgdate.getHours()-epg_start_hour;	//おしりにかかる番組
				}
				//情報付加
				obj.min = start_h*60*60 + pgdate.getMinutes()*60 + pgdate.getSeconds();	//番組表内座標
				obj.id = format04x(obj.original_network_id) + format04x(obj.transport_stream_id) + format04x(obj.service_id) + format04x(obj.event_id);
				obj.unix_time = pgdate.getTime()/1000;
				putprog(obj, station_idx);
			} catch(e2) {
				dbg("epg_rend:"+e);
			}
		}
		proglist[station_idx] = program;
	} catch(e) {
		dbg("epg_rend:"+e);
		console.log("epg_rend:"+e);
/*
		//キャッシュ無効
		privateStorage.setItem("epg_date_"+epg_dow+"_"+station_idx_tbl[station_idx], "");
*/
	}

	setTimeout(epg_download_next, 0);
}
function putprog(obj, stationindex) {
	var hour = Math.floor(obj.min/3600) + epg_start_hour;
	var min = format02d(Math.floor(((obj.min+24*3600)%3600)/60));
	var x = (stationindex * 100) / station_max;
	var w = (100/station_max - 0.2);
	var y = Math.floor(epg_hour_height*obj.min/3600);
	var h = Math.floor(epg_hour_height*obj.durationSec/3600) - 1;
	//両端切り落とし
	if (obj.min<0) {
		h = Math.floor(epg_hour_height*(obj.durationSec+obj.min)/3600) - 1;
		y = 0;
	}
	if (obj.min+obj.durationSec>24*60*60) {
		var dur = obj.durationSec - (obj.min+obj.durationSec - 24*60*60);
		h = Math.floor(epg_hour_height*dur/3600) - 1;
	}
	//ジャンル色
	var genreidx = 15;
	if (obj.ContentInfo!=null && obj.ContentInfo.nibbleList!=null && obj.ContentInfo.nibbleList.length>0) {
		genreidx = obj.ContentInfo.nibbleList[0].content_nibble_level_1;
	}
//	genreidx = 0;
//	GenreColor[0] = "#f0f0f0";
	//
	var tt = min;
	if (obj.min<0) tt = hour+":"+min;
	var timetext = "<a href='#' class='progmin' onclick='return false;'>"+tt+"</a>";
	var title="", explan="";
	var detailbtn = '<a href="#" class="detail" onclick="return false">[詳細]</a>';
	if (obj.ShortInfo && obj.ShortInfo.event_name) title = obj.ShortInfo.event_name;
	if (obj.ShortInfo && obj.ShortInfo.text_char) explan = obj.ShortInfo.text_char;
	//station
	var station = "";

	var text = '<div id="'+obj.id+'" name='+stationindex+' class="block border prog" style="BACKGROUND-COLOR: '+GenreColor[genreidx]+
	'; WIDTH: '+w+'%; LEFT: '+x+'%; HEIGHT: '+h+'px; TOP: '+y+'px"><div class="content"><span class="rec"></span>'+timetext+
	' <span class="progtitle">'+title+'</span>'+'<br><div class="subtitle">'+explan+'</div>'+detailbtn+'</div></div>\n';
	insert.append(text);
}
//..日付操作
function date_prev() {
	var tmp = viewdate.getTime();
	tmp -= 24 * 3600 * 1000;
	viewdate.setTime(tmp);
	epg_download(viewdate);
}
function date_next() {
	var tmp = viewdate.getTime();
	tmp += 24 * 3600 * 1000;
	viewdate.setTime(tmp);
	epg_download(viewdate);
}
//..予約dl
function epg_crc_download() {
	//予約受信
	//epg_reserve_download_done();
	//ラジオ版はバイパス	reserve_download(epg_reserve_download_done);

	//!epgのcrcは廃止
	//epgの更新日付が確認できるといいかもしれない
	
	//予約はepg読み込みの後でやってる
	//ここではプリセットを読み込む
	cmdpreset = new Array();
	apppreset = new Array();
	cgi_url("/cgi?cmd=getPreset", _getPreset_success, epg_reserve_download_done);
}
function _getPreset_success(response) {
	cmdpreset = response.cmdpreset;
	apppreset = response.apppreset;
	epg_reserve_download_done();
}
function epg_reserve_download_done() {
	epg_download(viewdate);
}
//予約リロード
var reserve_reload_callback;
function reserve_reload(cb) {
	reserve_reload_callback = cb;
	$(".rec").hide();
	reserve_download(reserve_reload_done);
}
function reserve_reload_done() {
	//予約チェック付ける
	for(var i = 0; i<reserve_list.length; i++) {
		if (reserve_list[i].EventID==0xffff) continue;
		//今表示している日付かチェックを入れる
		//表示しているチャンネルかチェック
		//チェックせずidでマークを付ける
		var recobj = $("#"+reserve_list[i].id).find(".rec").show();
		recobj.css("background-color", reserve_list[i].tuner_color);
		recobj.html("<span style='color: #ffffff;'>"+reserve_list[i].tuner_name+"</span>");
	}
	if (reserve_reload_callback) reserve_reload_callback();
}


//..チャンネル
var page_current;
function _page_list_idx(page) {
	var jsontext = privateStorage.getItem("radio_service_list");
	var params = JSON.parse(jsontext);
	var pagecnt = 0;
	for(var key in params) {
		var pm = params[key];
		if (pm.name=="hiddench") continue;
		pagecnt++;
		if (page != pagecnt-1) continue;
		return pm.list;
	}
	return null;
}
function page_channel_init(page) {
	if (page<0) page = page_current;
	else page_current = page;
	var list = _page_list_idx(page);
	if (!list) _page_list_idx(0);
	station_idx_tbl = new Array();
	for(var svkey in list) {
		station_idx_tbl.push(svkey);
	}
	//局名枠
	var hobj = $(".stationblock").children("div").empty();
	station_max = station_idx_tbl.length;
	var w = 100/station_max;
	for(var i = 0; i< station_max; i++) {
		hobj.append("<div class='block station' style='WIDTH: "+(w-0.2)+"%; LEFT: "+w*i+"%; HEIGHT: "+station_height+"px; TOP: 0px' onclick='push_station("+i+")'></div>");
	}
}

function page_init() {
	//ページ切り替えボタン差し込み
	var jq = $(".pagetable");
	
	var jsontext = privateStorage.getItem("radio_service_list");
	var params = JSON.parse(jsontext);
	var pagecnt = 0;
	for(var key in params) {
		jq.append("<a href='javascript:page_change("+pagecnt+")'>"+params[key].name+"</a>　")
		pagecnt++;
	}
}
function page_change(p) {
	reserve_window_release();
	page_channel_init(p);
	//epg_crc_download();
	epg_download(viewdate);
}

//.ラジオ用
function task_rec() {
	//プログラム予約（単発）
	var id = reserve_window.attr("id");
	var stpos = parseInt(reserve_window.attr("name"));
	var obj = null, progmax = proglist[stpos].length;
	for (var i = 0; i< progmax; i++) {
		if (proglist[stpos][i].id==id) {
			obj = $.extend(true, {}, proglist[stpos][i]);
			break;
		}
	}
	if (!obj) return;
	var preset = $('.preset option:selected').text();
	privateStorage.setItem("current_preset", preset);
	var param={};
	param.Title = title2(obj.ShortInfo.event_name);
	param.ServiceID = obj.service_id;
	param.TransportStreamID = obj.transport_stream_id;
	param.OriginalNetworkID = obj.original_network_id;
	param.EventID = obj.event_id;

	param.StartTime = obj.start_time;
	param.StationName = service_tbl["0000"+obj.id.substr(0, 12)].name;
	param.DurationSecond = obj.durationSec;
	param.Comment = obj.ShortInfo.text_char;
	param.RecFilePath = preset;
	param.param1 = 0;
	if($("[name=everyweek]").prop('checked')) {
		//毎週
		/// 対象曜日
		for(var i = 0; i< 7; i++) {
			if($("[name=week"+i+"]").prop('checked')) {
				param.param1 += parseInt($("[name=week"+i+"]").val());
			}
		}
	}
	console.log(":"+JSON.stringify(param));
	$("input:button").prop("disabled", true);
	cgi_param("/cgi", "cmd=SendAddTaskReserve&param="+encodeURIComponent(JSON.stringify([param])), task_rec_success, task_rec_failed);
}
function task_rec_success() {
	$("input:button").prop("disabled", false);
	reserve_window_release();
	reserve_reload();
}
function task_rec_failed() {
	$("input:button").prop("disabled", false);
	alert("予約に失敗しました");
}

//..予約リストダウンロード
var reserve_list = [];
var _rsv_dl_cb;
var tuner_color = [
	["#ff0000"],
	["#557238","#6a8d47","#80aa55","#95b872"],
	["#0055aa","#006ad5","#0080ff","#2b95ff"],
	["#5500aa","#6a00d5","#8000ff","#952bff",],
	["#aa5500","#d56a00","#ff8000","#ff952b",],
];
function reserve_download(cb) {
	_rsv_dl_cb = cb;
	reserve_list = [];
	cgi_url("/cgi?cmd=SendEnumReserve", _reserve_download_success, _reserve_download_failed);
}
function _reserve_download_success(response) {
	reserve_list = response;
	//idキーを付加する 予約するときに邪魔
	for(var i = 0; i<reserve_list.length; i++) {
		var obj = reserve_list[i];
		obj.id = format04x(obj.OriginalNetworkID) + format04x(obj.TransportStreamID) + format04x(obj.ServiceID) + format04x(obj.EventID);
		//dbg("reserve_id:"+obj.id);
		obj.tuner_name = "予約";
		obj.tuner_color = tuner_color[4][1];
	}
	if (_rsv_dl_cb) _rsv_dl_cb();
}
function _reserve_download_failed() {
	reserve_list = [];
	if (_rsv_dl_cb) _rsv_dl_cb();
}
function reserve_get() {
	return reserve_list;
}
/*function reserve_get_reserve(id) {
	for(var i = 0; i<reserve_list.length; i++) {
		var obj = reserve_list[i];
		if (obj.id==id) {
			return obj;
		}
	}
	return null;
}*/
/*function reserve_get_state(id) {
	for(var i = 0; i<reserve_list.length; i++) {
		var obj = reserve_list[i];
		if (obj.id==id) {
			if (obj.RecSetting.RecMode==5) {
				return 3;	//無効
			} else if (obj.OverlapMode==1) {
				return 1;	//欠け
			} else if (obj.OverlapMode==2) {
				return 2;	//全く予約できない
			}
			return 0;	//通常予約
		}
	}
	return -1;	//未予約
}*/
//detail用
function preset_get() {
	return cmdpreset;
}
function apppreset_get() {
	return apppreset;
}




function command_page_cache_clear() {
	setTimeout(function(){
		//現在表示しているデータのキャッシュクリア
		var date_list = [];
		if ($(".header_stmode").css("display")=="block") {
			if (viewdate.getTime() <= todaydate.getTime()) {
				viewdate = new Date(todaydate.getTime());
				viewdate.setDate(viewdate.getDate() - 8);
			} else {
				viewdate = new Date(todaydate.getTime());
			}
			for(var k = 0; k< 8; k++) {
				date_list.push(viewdate.getTime());
				viewdate.setDate(viewdate.getDate() + 1);
			}
		} else {
			for(var k = 0; k< station_idx_tbl.length; k++) date_list.push(viewdate);
		}
		var station_tag_tbl = new Array(station_idx_tbl.length);
		for(var i = 0; i< station_idx_tbl.length; i++) {
			station_tag_tbl[i] = service_tbl[station_idx_tbl[i]].tag;
		}
		var params = {
			"svlist"   : station_tag_tbl,
			"datelist" : date_list,
		};

		native_delete_cache(JSON.stringify(params));

		//epg_download(viewdate);
	},1);
}







