var service_list;
var selected_seprator;
var need_init = false;
var pagetemplate;
var service_tbl;

var seprator_tag = "<span class='seprator' onclick='clk_sep(this)'>｜ </span>";

$(document).ready(function(){
	//テンプレート吸い出し
	pagetemplate = $(".template").html();
	$(".template").remove();

	station_download_conn();
});
//.DL
function station_download_conn() {
	//チャンネル一覧をダウンロード
	cgi_url("/cgi?cmd=SendEnumRadioService", station_download_success, station_download_error);
}

function station_download_success(data) {
	//debug("conn:success:"+JSON.stringify(data));
	console.log(data);
	//
	var svl = data;//JSON.parse(data);
	service_list = new Array();
	service_tbl = {};//new Array();
	var arraycount = svl.length;
	for (var i=0; i< arraycount; i++) {
		if (svl[i].partialReceptionFlag==1) continue;	//ワンセグっぽいの捨て
		if (svl[i].service_type!=1) continue;	//デジタルＴＶサービス以外捨て
		var sv_idx = service_list.length;
		service_list[sv_idx] = {};
		var k = "0000" + format04x(svl[i].ONID) + format04x(svl[i].TSID) + format04x(svl[i].SID);
		service_list[sv_idx].key = k;
		service_list[sv_idx].name = svl[i].service_name;
		service_list[sv_idx].area = svl[i].remote_control_key_id;
		service_list[sv_idx].tag = svl[i].service_provider_name;
		var sv = service_list[sv_idx];
		//debug(sv.key+" "+sv.name);
		service_tbl[sv.key] = {};
		service_tbl[sv.key].name = sv.name;
		service_tbl[sv.key].area = sv.area;
		service_tbl[sv.key].tag = sv.tag;
	}
	privateStorage.setItem("radio_service_tbl", JSON.stringify(service_tbl));
	//ロード
	load();
	//初期化
	if (need_init) {
		var text, inspos=0;
		for(var i = 0; i< 6; i++) {
			text = pickup(i, false);
			if (text!="") {
				$("#page_insert").children(".pageblock").eq(inspos++).find(".stationlist").html(text);
			}
		}
		text = pickup(6, true);
		$("#hiddench").find(".stationlist").html(text);
		//空っぽのページを削除
		var pages = $("#page_insert").children(".pageblock");
		var page_max = pages.length;
		for(var i = page_max-1; i>=0; i--) {
			var contents = pages.eq(i).find(".stationlist").html();
			if (contents=="") {
				pages.eq(i).remove();
			}
		}
	} else {
		//差分を見て何かする
		for (var i=0; i< service_list.length; i++) {
			var sv = service_list[i];
			if (getpagebyid(sv.key)==-1) {
				//所属しないCHはハズレに放り込んでおく
				$("#hiddench").find(".stationlist").append("<span class='station' name='"+sv.key+"' onclick='clk_st(this)'><nobr>"+sv.name+"</nobr></span> ");
			}
		}
	}
}
function station_download_error(err) {
	debug("conn:failed:"+err);
}
function debug(text) {
	console.log(text);
	$(".debug").append(text+"<br />");
}
//.
function pickup(type, hidden) {
	var arraycount = service_list.length;
	var text = "";
	if (!hidden) {text = seprator_tag;}
	for (var i=0; i< arraycount; i++) {
		var sv = service_list[i];
		var onid = sv.area;
		var tsid = parseInt(sv.key.substr(8, 4),16);
		if ((type==0 && onid>0 && onid<=7)
		|| (type==1 && onid>7 && onid<=14)
		|| (type==2 && onid>14 && onid<=23)
		|| (type==3 && onid>23 && onid<=30)
		|| (type==4 && onid>30 && onid<=39)
		|| (type==5 && onid>39)
		|| (type==6 && onid==0)) {
			text += "<span class='station' name='"+sv.key+"' onclick='clk_st(this)'><nobr>"+sv.name+"</nobr></span> ";
			if (!hidden) {
				text += seprator_tag;
			}
		}
	}
	if (text==seprator_tag) return "";
	return text;
}
//.選択しているものを収集
function collect_selected(erase_flag) {
	var selected_items = new Array();
	var pages = $(".pageblock");
	var lastseprator = null;
	for(var i = 0; i< pages.length; i++) {
		var top = pages.eq(i);
		var hidden = (top.attr("id")=="hiddench") ? true : false;
		var svlist = top.find(".stationlist").children();
		for(var k = 0; k< svlist.length; k++) {
			var svobj = svlist.eq(k);
			if (svobj.hasClass("seprator")) {
				lastseprator = svobj;
			}
			if (svobj.hasClass("selected")) {
				svobj.removeClass("selected");
				selected_items.push(svobj.prop('outerHTML'));
				//移動or非表示は常に削除
				if (erase_flag || hidden) {
					svobj.remove();
					//次のセパレーターを消す
					if (!hidden) {
						svobj = svlist.eq(++k);
						if (svobj.is(selected_seprator)) {
							selected_seprator = lastseprator;
						}
						svobj.remove();
					}
				}
			}
		}
	}
	//console.log("COLLECT:"+selected_items.length);
	return selected_items;
}
function collect_push(items) {
	var text = "";
	for(var i = 0; i< items.length; i++) {
		text += items[i];
		text += seprator_tag;
	}
	selected_seprator.after(text);
}
//.局名クリック
function clk_st(obj) {
	console.log("clk_st:"+obj);
	if ($(obj).hasClass("selected")) {
		$(obj).removeClass("selected");
		return;
	}
//	$("span").removeClass("selected");	//全選択解除
	$(obj).addClass("selected");
}
//セパレータクリック
function clk_sep(obj) {
	//移動
	console.log("clk_sep:"+obj);
	//回収
	selected_seprator = $(obj);
	items = collect_selected(true);
	collect_push(items);
	return;
}
function clk_sep_copy(obj) {
	//コピー
	console.log("clk_sep_copy:"+obj);
	//回収
	selected_seprator = $(obj);
	items = collect_selected(false);
	collect_push(items);
}
//移動先をページで指定
function page_move(obj) {
	//ページ内のセパレータを検索
	var jsobj = $(obj);	//.parent(".pageblock");
	while((jsobj=jsobj.parent()).length>0) {
		if (jsobj.hasClass("pageblock")) break;
	}
	if (!jsobj.hasClass("pageblock")) return;
	var a = jsobj.children(".stationlist").children(".seprator");
	if (a) clk_sep(a.get(a.length-1));
}
function page_copy(obj) {
	//ページ内のセパレータを検索
	var jsobj = $(obj);	//.parent(".pageblock");
	while((jsobj=jsobj.parent()).length>0) {
		if (jsobj.hasClass("pageblock")) break;
	}
	if (!jsobj.hasClass("pageblock")) return;
	var a = jsobj.children(".stationlist").children(".seprator");
	if (a) clk_sep_copy(a.get(a.length-1));
}
//
function hidden_ch_move(obj) {
	//選択されているもの全部消す
	collect_selected(true);
	//非表示チャンネル再検索
	$("#hiddench").find(".stationlist").html("");
	for (var i=0; i< service_list.length; i++) {
		var sv = service_list[i];
		if (getpagebyid(sv.key)==-1) {
			//所属しないCHはハズレに放り込んでおく
			$("#hiddench").find(".stationlist").append("<span class='station' name='"+sv.key+"' onclick='clk_st(this)'><nobr>"+sv.name+"</nobr></span> ");
		}
	}
}
//.セーブロード
function save() {
	console.log("save");
	var data = new Object();
	var pages = $("#page_insert").children(".pageblock");
	for(var i = 0; i< pages.length; i++) {
		var top = pages.eq(i);
		var tag = "page_"+i;
		var name = top.find("input").val();
		if (top.attr("id")=="hiddench") name = "hiddench";
		var svhash = new Object();
		var svtag = new Array();
		//console.log(""+name);
		var svlist = top.find(".stationlist").find(".station");
		for(var k = 0; k< svlist.length; k++) {
			svobj = svlist.eq(k);
			var svkey = svobj.attr("name");
			var svname = svobj.text();
			//console.log(""+svkey+":"+svname);
			svhash[svkey] = svname;
			svtag.push(service_tbl[svkey].tag);
			//dbg("tag="+service_tbl[svkey].tag);
		}
		data[tag] = new Object();
		data[tag].name = name;
		data[tag].list = svhash;
		data[tag].tags = svtag;
	}
	//console.log(JSON.stringify(data));
	privateStorage.setItem("radio_service_list", JSON.stringify(data));

	//window.close();
	if (window.history.length>1) window.history.back();
	else location.href = "../index.html";
}
function load() {
	//console.log("load");
	var page_insert = $("#page_insert");
	var jsontext = privateStorage.getItem("radio_service_list");
	if (!jsontext || jsontext.length==0) {
		//初期化
		//6ページ用意する
		for(var i = 0; i< 6; i++) {
			page_insert.append(pagetemplate);
			var id = "page_"+i;
			obj = $("#temp00");
			obj.attr("id", id);
			obj.find("input").val("PAGE"+(i+1));
			obj.find("span").eq(0).html(i+1);
		}
		need_init = true;
		return;
	}
	//console.log("load"+jsontext);
	var params = JSON.parse(jsontext);
	var pagecnt = 0;
	for(var key in params) {
		var pm = params[key];
		var id, obj;
		if (pm.name!="hiddench") {
			page_insert.append(pagetemplate);
			id = "page_"+(pagecnt++);
			obj = $("#temp00");
			obj.attr("id", id);
			obj.find("input").val(pm.name);
			obj.find("span").eq(0).html(pagecnt);
		} else {
			id = "hiddench";
			obj = $("#hiddench");
		}
		var obj2 = obj.find(".stationlist");
		if (id!="hiddench") obj2.append(seprator_tag);
//		if (false) {
		if (pm.tags!=null) {
			for(var i=0; i<pm.tags.length; i++){
				//キーを再検索
				var svkey;
				for(svkey in service_tbl) {
					if (service_tbl[svkey].tag==pm.tags[i]) break;
				}
				obj2.append("<span class='station' name='"+svkey+"' onclick='clk_st(this)'><nobr>"+service_tbl[svkey].name+"</nobr></span> ");
				if (id!="hiddench") obj2.append(seprator_tag);
			}
		} else {
			for(var svkey in pm.list) {
				obj2.append("<span class='station' name='"+svkey+"' onclick='clk_st(this)'><nobr>"+pm.list[svkey]+"</nobr></span> ");
				if (id!="hiddench") obj2.append(seprator_tag);
			}
		}
	}
}
//.リセット
function reset() {
	privateStorage.setItem("radio_service_list", "");
	$("#page_insert").html("");
	$("#hiddench").find(".stationlist").html("");
	load();
	station_download_conn();
}
//.ページ操作
function add_page() {
	var pagecnt = $(".pageblock").length-1;
	var page_insert = $("#page_insert");
	page_insert.append(pagetemplate);
	id = "page_"+(pagecnt++);
	obj = $("#temp00");
	obj.attr("id", id);
	obj.find("input").val("PAGE"+pagecnt);
	obj.find("span").eq(0).html(pagecnt);
	var obj2 = obj.find(".stationlist");
	obj2.append(seprator_tag);
}
function page_del(obj) {
	var jsobj = $(obj);	//.parent(".pageblock");
	while((jsobj=jsobj.parent()).length>0) {
		if (jsobj.hasClass("pageblock")) break;
	}
	if (!jsobj.hasClass("pageblock")) return;
	//所属チャンネルを非表示に放り投げる
	var hiddenstation = $("#hiddench").find(".stationlist");
	var svdiv = jsobj.find(".stationlist");
	var svlist = svdiv.children(".station");
	for(var i = 0; i< svlist.length; i++) {
		var svobj = svlist.eq(i);
		var id = svobj.attr('name');
		var otherpagecnt = $("*[name="+id+"]").length - svdiv.find("*[name="+id+"]").length;
		if (otherpagecnt==0) {
			svobj.clone().appendTo(hiddenstation);
			hiddenstation.append(" ");
		}
	}
	//
	jsobj.remove();
}
//.検索
function getpagebyid(id) {
	//サービスIDからページ番号を得る(0～)
	var pagecnt = $(".pageblock").length-1;
	var pages = $("#page_insert").children(".pageblock");
	for(var i = 0; i< pages.length; i++) {
		var top = pages.eq(i);
		//console.log(""+name);
		var svlist = top.find(".stationlist").find(".station");
		for(var k = 0; k< svlist.length; k++) {
			svobj = svlist.eq(k);
			var svkey = svobj.attr("name");
			if (svkey==id) return i;
		}
	}
	return -1;
}






